<template>
  <v-form v-model="valid">
    <v-layout row wrap>
      <v-flex>
        <v-tabs>
          <v-tab @click="changeArea('fiche')">Fiche Client</v-tab>
          <v-tab @click="changeArea('prix-decli')">Adresses</v-tab>
          <!-- <v-tab @click="changeArea('categories')">Catégories</v-tab> -->
        </v-tabs>
      </v-flex>
    </v-layout>
    <v-container fluid grid-list-md text-xs-center>
      <!-- ###################################### ZONE FICHE ########################################## -->
      <v-layout v-if="area == 'fiche'" row wrap>
        <!-- =========================== Colonne gauche =========================== -->
        <v-flex md6>
          <!-- liste catégories -->
          <v-layout>
            <v-flex md12>
              <v-layout>
                <v-flex xs110>
                  <v-select @change="changeCat($event, 0, false)" v-model="selectedCat" :items="nodesCat" item-value="slug" item-text="title" box :label="enteteCategories[0]"></v-select>
                </v-flex>
                <v-flex xs2>
                  <v-btn v-if="selectedCat" @click="cancelCat(0)" small fab>
                    <i class="material-icons">cached</i>
                  </v-btn>
                </v-flex>
              </v-layout>
              <v-layout v-if="nodesScat1">
                <v-flex xs10>
                  <v-select @change="changeCat($event, 1, false)" v-if="selectedCat && nodesScat1.length > 0" v-model="selectedScat1" :items="nodesScat1" item-value="slug" item-text="title" box :label="enteteCategories[1]"></v-select>
                </v-flex>
                <v-flex xs2>
                  <v-btn v-if="selectedScat1" @click="cancelCat(1)" small fab>
                    <i class="material-icons">cached</i>
                  </v-btn>
                </v-flex>
              </v-layout>

              <v-layout v-if="nodesScat2">
                <v-flex xs10>
                  <v-select @change="changeCat($event, 2, false)" v-if="selectedScat1 && nodesScat2.length > 0" v-model="selectedScat2" :items="nodesScat2" item-value="slug" item-text="title" box :label="enteteCategories[2]"></v-select>
                </v-flex>
                <v-flex xs2>
                  <v-btn v-if="selectedScat2" @click="cancelCat(2)" small fab>
                    <i class="material-icons">cached</i>
                  </v-btn>
                </v-flex>
              </v-layout>
              <v-layout v-if="nodesScat3">
                <v-flex xs10>
                  <v-select v-if="selectedScat2 && nodesScat3.length > 0" v-model="selectedScat3" :items="nodesScat3" item-value="slug" item-text="title" box :label="enteteCategories[3]"></v-select>
                </v-flex>
                <v-flex xs2>
                  <v-btn v-if="selectedScat3" @click="cancelCat(3)" small fab>
                    <i class="material-icons">cached</i>
                  </v-btn>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>

          <!-- liste titres -->
          <v-layout v-for="(titre, index) in titreLabels" v-bind:key="titre.id">
            <!-- TRAITEMENT CODE PROMO pour ne pas afficher certains champs en fonction de la catégorie -->
            <v-flex xs12 v-if="selectedCat && isCodePromo !== -1 && titre.toString() == 'Remise montant' && selectedCat.toString() == 'frais-de-port-offerts'"> </v-flex>

            <v-flex xs12 v-else>
              <v-text-field v-model="mTitre[index + 1]" :label="titre"></v-text-field>
            </v-flex>
          </v-layout>

          <!-- liste standard -->
          <v-layout v-for="(liste, index) in listeLabels" :key="liste.id">
            <v-flex xs12 d-flex>
              <v-select :items="contentListes[index]" item-text="name" item-value="value" :label="liste" v-model="mListe[index + 1]"></v-select>
            </v-flex>
          </v-layout>

          <v-layout row wrap v-if="switchLabels.length > 0 || ouiLabels > 0">
            <v-container fluid grid-list-md px-0>
              <div class="v-sheet v-sheet--tile theme--light">
                <v-layout row wrap>
                  <!-- liste switch -->
                  <v-flex xs6>
                    <div v-if="selectedCat && isCodePromo !== -1 && selectedCat.toString() == 'frais-de-port-offerts'"></div>
                    <div v-else>
                      <v-switch v-model="mSwitch[index + 1]" :label="sw" v-for="(sw, index) in switchLabels" v-bind:key="sw.id"></v-switch>
                    </div>
                  </v-flex>

                  <!-- v-if="selectedCat && isCodePromo !== -1 && oui.toString() == 'Calcul en pourcentage' && selectedCat.toString() == 'frais-de-port-offerts'"-->

                  <v-flex xs6>
                    <v-radio-group v-if="action == 'edit'" v-model="modeleOui">
                      <v-radio v-for="(oui, index) in ouiLabels" :key="index" :label="oui" :value="ouiValues[index]"></v-radio>
                    </v-radio-group>

                    <v-radio-group v-else v-model="mOui">
                      <v-radio v-for="(oui, index) in ouiLabels" :key="index" :label="oui" :value="ouiValues[index]"></v-radio>
                    </v-radio-group>
                  </v-flex>
                </v-layout>
              </div>
            </v-container>
          </v-layout>
        </v-flex>
        <!-- =========================== Colonne droite =========================== -->
        <v-flex md6 style="overflow: hidden">
          <!-- liste description -->
          <v-expansion-panel v-model="panel" expand>
            <v-expansion-panel-content v-for="(desc, index) in descriptionLabels" v-bind:key="desc.id">
              <template v-slot:header>
                <div>{{ desc }}</div>
              </template>
              <v-card>
                <v-card-text>
                  <wysiwyg v-model="mDescription[index + 1]" placeholder />
                </v-card-text>
              </v-card>
            </v-expansion-panel-content>
          </v-expansion-panel>
          <br />
          <hr />
          <!-- Validation du formulaire (fiche)-->

          <v-layout>
            <v-flex xs12>
              <v-switch v-model="News.actif" label="Activer la fiche client" color="success" hide-details></v-switch>
            </v-flex>
          </v-layout>

          <!-- gestion des ordres -->
          <v-layout>
            <v-flex xs12>
              <v-text-field v-model="News.ordre" label="Classement numérique" :rules="orderRules"></v-text-field>
            </v-flex>
          </v-layout>

          <!-- <v-layout>
            <v-flex xs12>
              <v-btn block color="success" @click="passingDataAndSubmit()">{{ libelleAction }}</v-btn>
            </v-flex>

            <v-flex xs12 v-if="action == 'edit'">
              <v-btn block color="error" @click="deleteFiche()">Supprimer</v-btn>
            </v-flex>
          </v-layout>-->
        </v-flex>
      </v-layout>
      <!-- ###################################### ZONE INFORMATIONS TARIFAIRES #################################### -->
      <v-layout v-if="area == 'prix-decli'">
        <v-flex md12>
          <!-- Création prix déclinaison -->
          <!-- #PD -->
          <div id="detaildecli"></div>

          <v-layout>
            <v-flex>
              <v-layout row wrap>
                <v-flex d-flex>
                  <v-text-field label="Référence" box v-model="selectedDecli.reference"></v-text-field>
                </v-flex>
                <v-flex d-flex v-for="(property, index) in labelProperties" :key="property.id">
                  <v-text-field :label="property" box v-model="selectedDecli.properties[index]"></v-text-field>
                </v-flex>
              </v-layout>
              <v-layout row wrap>
                <v-flex d-flex md2 v-for="(prixD, index) in labelsPriceDeclinaisons" :key="prixD.id">
                  <v-text-field v-model="selectedDecli.prices[index]" :rules="numberRules" :label="prixD.text" box></v-text-field>
                </v-flex>

                <v-flex d-flex md3>
                  <v-btn block color="warning" large v-if="isEditDeclinaison" @click="validEditDeclinaison()">Modifier l'adresse</v-btn>
                  <v-btn block color="success" large v-else @click="addDeclinaison()">Ajouter une adresse</v-btn>
                </v-flex>

                <v-btn color="warning" fab small dark v-if="isEditDeclinaison" @click="cancelEditDecli()">
                  <i class="material-icons">cached</i>
                </v-btn>
              </v-layout>

              <!-- tableau déclinaison datatable -->
              <!-- #TD -->
              <v-layout>
                <v-flex xs12>
                  <v-data-table v-model="selected" :headers="headers" :items="declinaisons" :pagination.sync="pagination" select-all item-key="reference" class="elevation-1">
                    <template v-slot:headers="props">
                      <tr>
                        <th>Supprimer</th>
                        <th>editer</th>
                        <th v-for="header in props.headers" :key="header.text" :class="['column sortable', pagination.descending ? 'desc' : 'asc', header.value === pagination.sortBy ? 'active' : '']" @click="changeSort(header.value)">
                          <v-icon small>arrow_upward</v-icon>
                          {{ header.text }}
                        </th>
                      </tr>
                    </template>
                    <template v-slot:items="props">
                      <tr :active="props.selected" @click="props.selected = !props.selected">
                        <td>
                          <v-btn color="error" fab small dark @click="deleteDeclinaison(props.item.id, props.index)">
                            <v-icon>delete_forever</v-icon>
                          </v-btn>
                        </td>
                        <td>
                          <v-btn color="primary" fab small dark @click="editDeclinaison(props.item, props.index)">
                            <v-icon>edit</v-icon>
                          </v-btn>
                        </td>
                        <td>{{ props.item.reference }}</td>

                        <!-- boucle sur les champs propriétés du tableaux des déclinaisons -->
                        <td v-for="(property, index) in labelProperties" :key="property.id" class="text-xs-center">{{ props.item.properties[index] }}</td>

                        <!-- boucle sur les champs prix du tableaux des déclinaisons -->
                        <td class="text-xs-center" v-for="(prixD, index) in labelsPriceDeclinaisons" :key="prixD.id">{{ props.item.prices[index] }}</td>
                      </tr>
                    </template>
                  </v-data-table>
                </v-flex>
              </v-layout>
            </v-flex>
          </v-layout>
        </v-flex>
      </v-layout>

      <!-- ###################################### ZONE CATEGORIES ########################################## -->
      <v-layout v-if="area == 'categories'">
        <v-container grid-list-md>
          <sl-vue-tree-component :modulesCategories="modulesCategories" :fiche="true" @onCategoriesChange="refreshCategories"></sl-vue-tree-component>
        </v-container>
        {{ modulesCategories }}
      </v-layout>
    </v-container>
    <v-snackbar color="red" top v-model="snackbar.actif" :multi-line="snackbar.multiLine">
      {{ snackbar.text }}
      <v-btn color="primary" text @click="snackbar.actif = false">Fermer</v-btn>
    </v-snackbar>

    <v-layout>
      <v-flex xs12>
        <v-btn block color="success" @click="passingDataAndSubmit()">{{ libelleAction }}</v-btn>
      </v-flex>
      <!-- Désactivé en attente gestion dynamique lien retour-->
      <!--
            <v-flex xs12>
              <v-btn block color="warning" @click="backToList()">Retour</v-btn>
            </v-flex>
      -->
      <v-flex xs12 v-if="action == 'edit'">
        <v-btn block color="error" @click="deleteFiche()">Supprimer</v-btn>
      </v-flex>
    </v-layout>
  </v-form>
</template>
<style scoped>
.zoneimagesource {
  width: 400px;
  /* height:300px;  */
  /* border: 1px solid gray;  */
  display: inline-block;
}
.cropImg {
  width: 200px;
  height: 150px;
  border: 1px solid gray;
}
</style>
<script src="./_form.js"></script>
